package sim;

public interface IEventSimModelUnit {

	// Waiting time computations
//	long getWaitingTimeUntilDeath( KnuthRandom r );
//	long getWaitingTimeUntilMutation( KnuthRandom r );
//	long getWaitingTimeUntilDivision( KnuthRandom r );
	
	// Event handlers
	void die() throws Exception;
	void divide() throws Exception;
	void mutate() throws Exception;

	// Event generation
	//SimulationEvent GetNextEventOfType( SimulationEvent.EventType eventType );
	SimulationEvent GenerateDeathEvent();  			// one and only death event
	SimulationEvent GenerateMutationEvent();  		// one and only mutation event
	SimulationEvent GenerateNextDivisionEvent();  	// any number of division events

	// Event queue management
//	void AddEventRef( SimulationEvent simEvent );
//	void RemoveEventRef( SimulationEvent simEvent );
//	ArrayList<SimulationEvent> GetCurrentEvents();
}
